package RNA::AutoDiscovery;
#=============================================================================
# Copyright (C) 2003,2004           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================
#
# 
#=============================================================================

use strict;
use Carp;
use vars qw($VERSION);

$VERSION = '0.1';

my %field = (
	links => [
		{
			title => '',
			rel => '', 
			rev => '', 
			href => '',
		},
		{},
	]
);


# $ad = RNA::AutoDiscovery->new(html=>'<html>...</html>');
sub new {
	my $class = shift;
	my $self = {};
	my %arg = @_;

	bless $self, $class;

	$self->parse($arg{html});
	
	return $self;
}

sub init
{
	my $self = shift;

	$self->{links} = [];
}

# $self->parse($str)
#
sub parse {
	my $self = shift;
	$self->init;

	my $str = shift;

	while($str =~ s/<link(.*?)\/?>//s)  {
		my ($attr) = ($1);

		my $attr_ref = {};
		while($attr =~ s/(\S+?)=['"](.+?)['"]//s) {
			$attr_ref->{$1} = $2;
		}

		push(@{$self->{links}}, $attr_ref);
	}
}

sub parsefile {
	my $self = shift;
	my $file = shift;
	open(IN, $file) || croak "Cannot open file $file : $!";
	my $str = "";
	while(my $s = <IN>){
		$str .= $s;
	}
	$self->parse($str);
}

# my @links = $self->links;
sub links
{
	my $self = shift;
	return $self->{links};
}


# my $link = $self->search($attr_name, $attr_value);
sub search
{
	my $self = shift;
	my ($attr_name, $attr_value) = @_;

	foreach my $link (@{$self->links}) {
		if($link->{$attr_name} eq $attr_value) {
			return $link;
		}
	}

	return undef;
}

# my $link = $self->search_alternate($attr_name, $attr_value);
sub search_alternate
{
	my $self = shift;
	my ($attr_name, $attr_value) = @_;

	foreach my $link (@{$self->links}) {
		if($link->{$attr_name} eq $attr_value && $link->{rel} eq 'alternate') {
			return $link;
		}
	}

	return undef;
}


#=============================================================================
1;
__END__

