#=============================================================================
# Copyright (C) 2003,2004           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================
# 　Bulkfeeds API 用モジュール
#=============================================================================
package RNA::Net::Bulkfeeds;

use strict;
use Carp;
use LWP::UserAgent;
use HTTP::Request::Common;
use RNA::Utils;

use vars qw($VERSION);
$VERSION = '0.1';

my %SITE_SEARCH_URI = (
	rdf  => 'http://bulkfeeds.net/app/search.rdf',
	rss  => 'http://bulkfeeds.net/app/search.rdf',
	opml => 'http://bulkfeeds.net/app/search.opml',
	html => 'http://bulkfeeds.net/app/search'
);

my %ENTRY_SEARCH_URI = (
	rdf  => 'http://bulkfeeds.net/app/search2.rdf',
	rss  => 'http://bulkfeeds.net/app/search2.rdf',
	html => 'http://bulkfeeds.net/app/search2'
);




# $bulkfeeds = new RNA::Net::Bulkfeeds;
sub new 
{
	my $class = shift;
	my $self = {};
	my %hash  = @_;

	bless $self, $class;

	$self->init(%hash);

	return $self;
}


sub init {
	my $self = shift;
	my %hash = @_;
}


# $uri = $self->site_search_uri(type=>'rss');
#	type : rdf, rss, opml, html
#
sub site_search_uri
{
	my $self = shift;
	my %arg = @_;
	my $type = lc($arg{type} || 'html');

	return $SITE_SEARCH_URI{$type};
}

# $uri = $self->entry_search_uri(type=>'rss');
#	type : rdf, rss, html
#
sub entry_search_uri
{
	my $self = shift;
	my %arg = @_;
	my $type = lc($arg{type} || 'html');

	return $ENTRY_SEARCH_URI{$type};
}


# my $rss_str = $self->search_sites(type=>'rss', q=>$q, field=>$field);
sub search_sites
{
	my $self = shift;
	my %arg   = @_;
	my $type  = $arg{type};
	my $q     = $arg{q};
	my $field = $arg{field};

	my $uri= $self->site_search_uri(type=>$type);

	my $req_uri = "$uri?q=".url_encode($q)."&field=". url_encode($field);
	return $self->http_get(uri=>$req_uri);
}

# my $rss_str = $self->search_sites(type=>'rss', q=>$q, field=>$field);
sub search_sites
{
	my $self = shift;
	my %arg   = @_;
	my $type  = $arg{type};
	my $q     = $arg{q};
	my $field = $arg{field};

	my $uri= $self->site_search_uri(type=>$type);

	my $req_uri = "$uri?q=".url_encode($q)."&field=". url_encode($field);
	return $self->http_get(uri=>$req_uri);
}


# my $rss_str = $self->search_entries(type=>'rss', q=>$q, sort=>'date');
#	type : rdf, rss, html
#	sort : date, score
sub search_entries
{
	my $self = shift;
	my %arg   = @_;
	my $type  = $arg{type};
	my $q     = $arg{q};
	my $sort  = $arg{sort};

	my $uri= $self->entry_search_uri(type=>$type);

	my $req_uri = "$uri?q=".url_encode($q)."&sort=". url_encode($sort);
	return $self->http_get(uri=>$req_uri);
}


# $html = $self->http_get(uri=>$uri);
#
sub http_get
{
	my $self = shift;
	my %arg = @_;
	my $uri = $arg{uri};

	my $req = GET $uri;

	# send request 
	my $ua = LWP::UserAgent->new;
	$ua->agent(__PACKAGE__ . '/' . $VERSION . " ($ua->agent)");
	#	$ua->timeout($timeout);
	$ua->parse_head(0); # HTML::HeadParser を必要としないように  
	my $res = $ua->request($req);

	# http header
	my $headers = $res->headers();

	# check
	if ($res->is_success) {
# print "Content-type:text/plain\n\n " . $res->content;
		return $res->content;
	}
	else {
#		print "Error: " . $res->status_line . "\n";
		return '';
	}
}

# $str = &url_encode($str)
sub url_encode
{
	return RNA::Utils::url_encode(@_);
}


#==============================================================================
1;

