#!/usr/bin/perl
#=============================================================================
# RNA initialize CGI
# 　　
#=============================================================================
# Copyright (C) 2003,2004           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================

# ライブラリ
use strict;
use lib qw(lib extlib);
use CGI;
use RNA;
use RNA::Utils qw(:all);

#==============================================================================
# 
#==============================================================================
my $cgi = new CGI;
my $rna = RNA->new(Config => './config.pl');
my $config = $rna->{Config};

# Background
my $background = $cgi->param('background');
if($background) {
	$config->{Update}->{Background} = ($background eq 'yes') ? 1 : 0
}

my $transfer_uri = $rna->{Config}->{MainIndex}->{URI};
my $response = $cgi->redirect($transfer_uri);


# generate cipher key
my $enckey = &gen_key_hex24;
eval{&print_file($config->{Authentication}->{CipherKeyFile}, \$enckey);};
&die_handler($@) if($@);

# initialize 
$rna->run(Mode=>'Update', TransferURI=>$transfer_uri, Response => $response);



#==============================================================================
# sub routine
#==============================================================================

# $key = &gen_key_hex24;
#   96bit
sub gen_key_hex24
{
	return unpack('H*', pack('V*', $$, time(), rand(999999)));
}

